// *** AUTOGENERATED FILE - Do not edit manually! - Changes will be overwritten! *** //

#include <string.h>
#include <stddef.h>
#include "generated/telemetry.h"
#include "generated/checksum.h"


/**
 * Send the serialized telemetry.
 *
 * @param data The serialized telemetry in a buffer.
 * @param size The size of the serialized telemetry in bytes.
 * @return Whether writing the telemetry was successful.
 */
extern bool writeTelemetry(void* data, size_t size);

/** Data for the HEARTBEAT message. */
typedef struct PACKED {
    /** The time the heartbeat was generated in milliseconds since boot. */
    ms_t time;
} TelemetryHeartbeatData;

/** A HEARTBEAT message. */
typedef struct PACKED {
    /** The message header. */
    TelemetryMessageHeader header;
    /** The message data. */
    TelemetryHeartbeatData data;
} TelemetryHeartbeatType;

/** Data for the RESPONSE message. */
typedef struct PACKED {
    /** The counter number of the command that generated this response. */
    uint8_t commandNumber;
    /** The response value of the command. */
    uint8_t value[MAX_TELECOMMAND_RESPONSE_SIZE];
} TelemetryResponseData;

/** A RESPONSE message. */
typedef struct PACKED {
    /** The message header. */
    TelemetryMessageHeader header;
    /** The message data. */
    TelemetryResponseData data;
} TelemetryResponseType;

/** Data for the ACKNOWLEDGE message. */
typedef struct PACKED {
    /** The counter number of the command that this telemetry acknowledges. */
    uint8_t commandNumber;
} TelemetryAcknowledgeData;

/** A ACKNOWLEDGE message. */
typedef struct PACKED {
    /** The message header. */
    TelemetryMessageHeader header;
    /** The message data. */
    TelemetryAcknowledgeData data;
} TelemetryAcknowledgeType;

/** Data for the MESSAGE message. */
typedef struct PACKED {
    /** The time the message was generated in milliseconds since the boot. */
    ms_t time;
    /** The type of the message. */
    TYPED_ENUM(MessageType, uint8_t) type;
    /** The size of the message in bytes. */
    uint16_t size;
    /** The message text. */
    char message[0];
} TelemetryMessageData;

/** A MESSAGE message. */
typedef struct PACKED {
    /** The message header. */
    TelemetryMessageHeader header;
    /** The message data. */
    TelemetryMessageData data;
} TelemetryMessageType;

/** Data for the DATA1 message. */
typedef struct PACKED {
    /** The current system time in milliseconds since boot. */
    ms_t time;
    /** The temperature of the processor in °C. */
    celsius_t processorTemperature;
    /** The temperature read from the thermal sensor which close to the battery in °C. */
    celsius_t batteryTemperature;
    /** The temperature read from the thermal sensor which close to the PDU PCB in °C. */
    celsius_t PduPcbTemperature;
    /** The temperature read from the thermal sensor which close to the motor controllers in °C. */
    celsius_t motorControllerTemperature;
    /** The temperature read from the thermal sensor which close to the motor bracket in °C. */
    celsius_t motorBracketTemperature;
    /** The temperature read from the thermal sensor which close to the retention wall in °C. */
    celsius_t retentionWallTemperature;
    /** The temperature read from the thermal sensor which close to the recovery wall in °C. */
    celsius_t recoveryWallTemperature;
    /** The temperature of the primary IMU in °C. */
    celsiusInt8_t primaryImuTemperature;
    /** The temperature of the secondary IMU in °C. */
    celsiusInt8_t secondaryImuTemperature;
    /** The current drawn by the motors in ampere. */
    Vec3F motorCurrent;
    /** The rotations in radians per seconds measured by the secondary IMU. */
    Vec3F secondaryImuRotation;
} TelemetryData1Data;

/** A DATA1 message. */
typedef struct PACKED {
    /** The message header. */
    TelemetryMessageHeader header;
    /** The message data. */
    TelemetryData1Data data;
} TelemetryData1Type;

/** Data for the DATA2 message. */
typedef struct PACKED {
    /** The current system time in milliseconds since boot. */
    ms_t time;
    /**
     * The acceleration on the x (roll) axis in meters per second squared measured by the primary
     * IMU.
     */
    mps2_t primaryXAcceleration;
    /**
     * The acceleration on the y (pitch) axis in meters per second squared measured by the primary
     * IMU.
     */
    mps2_t primaryYAcceleration;
    /**
     * The acceleration on the z (yaw) axis in meters per second squared measured by the primary
     * IMU.
     */
    mps2_t primaryZAcceleration;
    /** The magnetic force on the x (roll) axis in micro Tesla measured by the primary IMU. */
    microTesla_t primaryXMagneticForce;
    /** The magnetic force on the y (pitch) axis in micro Tesla measured by the primary IMU. */
    microTesla_t primaryYMagneticForce;
    /** The magnetic force on the z (yaw) axis in micro Tesla measured by the primary IMU. */
    microTesla_t primaryZMagneticForce;
    /**
     * The acceleration on the x (roll) axis in meters per second squared measured by the secondary
     * IMU.
     */
    mps2_t secondaryXAcceleration;
    /**
     * The acceleration on the y (pitch) axis in meters per second squared measured by the secondary
     * IMU.
     */
    mps2_t secondaryYAcceleration;
    /**
     * The acceleration on the z (yaw) axis in meters per second squared measured by the secondary
     * IMU.
     */
    mps2_t secondaryZAcceleration;
    /** The magnetic force on the x (roll) axis in micro Tesla measured by the secondary IMU. */
    microTesla_t secondaryXMagneticForce;
    /** The magnetic force on the y (pitch) axis in micro Tesla measured by the secondary IMU. */
    microTesla_t secondaryYMagneticForce;
    /** The magnetic force on the z (yaw) axis in micro Tesla measured by the secondary IMU. */
    microTesla_t secondaryZMagneticForce;
    /** The current pressure in bar. */
    bar_t pressure;
    /** The current state of the system state machine. */
    TYPED_ENUM(SystemState, uint8_t) state;
} TelemetryData2Data;

/** A DATA2 message. */
typedef struct PACKED {
    /** The message header. */
    TelemetryMessageHeader header;
    /** The message data. */
    TelemetryData2Data data;
} TelemetryData2Type;

/** Data for the DATA3 message. */
typedef struct PACKED {
    /** The current system time in milliseconds since boot. */
    ms_t time;
    /** The current orientation calculated by the primary IMU using sensor fusion. */
    Quaternion orientation;
    /** The voltage level of the FFU battery in volt. */
    voltFloat_t batteryLevel;
} TelemetryData3Data;

/** A DATA3 message. */
typedef struct PACKED {
    /** The message header. */
    TelemetryMessageHeader header;
    /** The message data. */
    TelemetryData3Data data;
} TelemetryData3Type;

/** Data for the DATA_MOTOR_SPEEDS message. */
typedef struct PACKED {
    /** The number of motor speeds in this telemetry package. */
    uint8_t motorSpeedCount;
    /** The speed of the motors in rotations per minute since the last telemetry package. */
    Vec3FWithTime motorSpeeds[0];
} TelemetryDataMotorSpeedsData;

/** A DATA_MOTOR_SPEEDS message. */
typedef struct PACKED {
    /** The message header. */
    TelemetryMessageHeader header;
    /** The message data. */
    TelemetryDataMotorSpeedsData data;
} TelemetryDataMotorSpeedsType;

/** Data for the DATA_ROTATION_SPEEDS message. */
typedef struct PACKED {
    /** The number of rotation speeds in this telemetry package. */
    uint8_t rotationSpeedCount;
    /**
     * The measured rotations in radians per seconds by the primary IMU since the last telemetry
     * package.
     */
    Vec3FWithTime rotationSpeeds[0];
} TelemetryDataRotationSpeedsData;

/** A DATA_ROTATION_SPEEDS message. */
typedef struct PACKED {
    /** The message header. */
    TelemetryMessageHeader header;
    /** The message data. */
    TelemetryDataRotationSpeedsData data;
} TelemetryDataRotationSpeedsType;

/** Data for the DATA_SET_POINTS message. */
typedef struct PACKED {
    /** The number of set points in this telemetry package. */
    uint8_t setPointsCount;
    /**
     * The targeted motor speeds in rotations per minute generated by the controller with time
     * stamps since the last telemetry.
     */
    Vec3Int32WithTime setPoints[0];
} TelemetryDataSetPointsData;

/** A DATA_SET_POINTS message. */
typedef struct PACKED {
    /** The message header. */
    TelemetryMessageHeader header;
    /** The message data. */
    TelemetryDataSetPointsData data;
} TelemetryDataSetPointsType;

/** Data for the DATA_RECOVERY message. */
typedef struct PACKED {
    /** The current system time in milliseconds since boot. */
    ms_t time;
    /** The GPS time of week of the navigation epoch in milliseconds. */
    ms_t gpsTime;
    /** Longitude in degrees. */
    deg_t longitude;
    /** Latitude in degrees. */
    deg_t latitude;
    /** The height above the ellipsoid in meter. */
    meter_t height;
    /** The current state of the recovery system. */
    TYPED_ENUM(RecoveryState, uint8_t) recoveryState;
} TelemetryDataRecoveryData;

/** A DATA_RECOVERY message. */
typedef struct PACKED {
    /** The message header. */
    TelemetryMessageHeader header;
    /** The message data. */
    TelemetryDataRecoveryData data;
} TelemetryDataRecoveryType;



bool sendTelemetryHeartbeat(ms_t time) {
    size_t messageSize = sizeof(TelemetryHeartbeatType);
    TelemetryHeartbeatType data;
    data.header.syncByte1 = SYNC_BYTE_1;
    data.header.syncByte2 = SYNC_BYTE_2;
    data.header.type = (uint8_t) TELEMETRY_HEARTBEAT;
    data.data.time = time;
    data.header.checksum = calculateChecksum(
        &((uint8_t*) &data.header.checksum)[sizeof(data.header.checksum)],
        messageSize - sizeof(data.header.syncByte1)
        - sizeof(data.header.syncByte2) - sizeof(data.header.checksum));
    return writeTelemetry(&data, messageSize);
}

bool sendTelemetryResponse(uint8_t commandNumber, const uint8_t* value) {
    size_t messageSize = sizeof(TelemetryResponseType);
    TelemetryResponseType data;
    data.header.syncByte1 = SYNC_BYTE_1;
    data.header.syncByte2 = SYNC_BYTE_2;
    data.header.type = (uint8_t) TELEMETRY_RESPONSE;
    data.data.commandNumber = commandNumber;
    memcpy(&data.data.value, value, sizeof(data.data.value));
    data.header.checksum = calculateChecksum(
        &((uint8_t*) &data.header.checksum)[sizeof(data.header.checksum)],
        messageSize - sizeof(data.header.syncByte1)
        - sizeof(data.header.syncByte2) - sizeof(data.header.checksum));
    return writeTelemetry(&data, messageSize);
}

bool sendTelemetryAcknowledge(uint8_t commandNumber) {
    size_t messageSize = sizeof(TelemetryAcknowledgeType);
    TelemetryAcknowledgeType data;
    data.header.syncByte1 = SYNC_BYTE_1;
    data.header.syncByte2 = SYNC_BYTE_2;
    data.header.type = (uint8_t) TELEMETRY_ACKNOWLEDGE;
    data.data.commandNumber = commandNumber;
    data.header.checksum = calculateChecksum(
        &((uint8_t*) &data.header.checksum)[sizeof(data.header.checksum)],
        messageSize - sizeof(data.header.syncByte1)
        - sizeof(data.header.syncByte2) - sizeof(data.header.checksum));
    return writeTelemetry(&data, messageSize);
}

bool sendTelemetryMessage(ms_t time, MessageType type, uint16_t size, const char* message) {
    size_t messageSize = sizeof(TelemetryMessageType) + size * sizeof(message[0]);
    uint8_t dataBuffer[messageSize];
    TelemetryMessageType* data = (TelemetryMessageType*) dataBuffer;
    data->header.syncByte1 = SYNC_BYTE_1;
    data->header.syncByte2 = SYNC_BYTE_2;
    data->header.type = (uint8_t) TELEMETRY_MESSAGE;
    data->data.time = time;
    data->data.type = (uint8_t) type;
    data->data.size = size;
    memcpy(&data->data.message, message, size * sizeof(message[0]));
    data->header.checksum = calculateChecksum(
        &((uint8_t*) &data->header.checksum)[sizeof(data->header.checksum)],
        messageSize - sizeof(data->header.syncByte1)
        - sizeof(data->header.syncByte2) - sizeof(data->header.checksum));
    return writeTelemetry(data, messageSize);
}

bool sendTelemetryData1(ms_t time, celsius_t processorTemperature, celsius_t batteryTemperature,
    celsius_t PduPcbTemperature, celsius_t motorControllerTemperature,
    celsius_t motorBracketTemperature, celsius_t retentionWallTemperature,
    celsius_t recoveryWallTemperature, celsiusInt8_t primaryImuTemperature,
    celsiusInt8_t secondaryImuTemperature, const Vec3F* motorCurrent,
    const Vec3F* secondaryImuRotation) {
    size_t messageSize = sizeof(TelemetryData1Type);
    TelemetryData1Type data;
    data.header.syncByte1 = SYNC_BYTE_1;
    data.header.syncByte2 = SYNC_BYTE_2;
    data.header.type = (uint8_t) TELEMETRY_DATA1;
    data.data.time = time;
    data.data.processorTemperature = processorTemperature;
    static_assert(sizeof(float) == 4,
        "float has an invalid size on this platform and can not be used");
    data.data.batteryTemperature = batteryTemperature;
    static_assert(sizeof(float) == 4,
        "float has an invalid size on this platform and can not be used");
    data.data.PduPcbTemperature = PduPcbTemperature;
    static_assert(sizeof(float) == 4,
        "float has an invalid size on this platform and can not be used");
    data.data.motorControllerTemperature = motorControllerTemperature;
    static_assert(sizeof(float) == 4,
        "float has an invalid size on this platform and can not be used");
    data.data.motorBracketTemperature = motorBracketTemperature;
    static_assert(sizeof(float) == 4,
        "float has an invalid size on this platform and can not be used");
    data.data.retentionWallTemperature = retentionWallTemperature;
    static_assert(sizeof(float) == 4,
        "float has an invalid size on this platform and can not be used");
    data.data.recoveryWallTemperature = recoveryWallTemperature;
    static_assert(sizeof(float) == 4,
        "float has an invalid size on this platform and can not be used");
    data.data.primaryImuTemperature = primaryImuTemperature;
    data.data.secondaryImuTemperature = secondaryImuTemperature;
    memcpy(&data.data.motorCurrent, motorCurrent, sizeof(data.data.motorCurrent));
    memcpy(&data.data.secondaryImuRotation, secondaryImuRotation, sizeof(data.data.secondaryImuRotation));
    data.header.checksum = calculateChecksum(
        &((uint8_t*) &data.header.checksum)[sizeof(data.header.checksum)],
        messageSize - sizeof(data.header.syncByte1)
        - sizeof(data.header.syncByte2) - sizeof(data.header.checksum));
    return writeTelemetry(&data, messageSize);
}

bool sendTelemetryData2(ms_t time, mps2_t primaryXAcceleration, mps2_t primaryYAcceleration,
    mps2_t primaryZAcceleration, microTesla_t primaryXMagneticForce,
    microTesla_t primaryYMagneticForce, microTesla_t primaryZMagneticForce,
    mps2_t secondaryXAcceleration, mps2_t secondaryYAcceleration, mps2_t secondaryZAcceleration,
    microTesla_t secondaryXMagneticForce, microTesla_t secondaryYMagneticForce,
    microTesla_t secondaryZMagneticForce, bar_t pressure, SystemState state) {
    size_t messageSize = sizeof(TelemetryData2Type);
    TelemetryData2Type data;
    data.header.syncByte1 = SYNC_BYTE_1;
    data.header.syncByte2 = SYNC_BYTE_2;
    data.header.type = (uint8_t) TELEMETRY_DATA2;
    data.data.time = time;
    data.data.primaryXAcceleration = primaryXAcceleration;
    static_assert(sizeof(float) == 4,
        "float has an invalid size on this platform and can not be used");
    data.data.primaryYAcceleration = primaryYAcceleration;
    static_assert(sizeof(float) == 4,
        "float has an invalid size on this platform and can not be used");
    data.data.primaryZAcceleration = primaryZAcceleration;
    static_assert(sizeof(float) == 4,
        "float has an invalid size on this platform and can not be used");
    data.data.primaryXMagneticForce = primaryXMagneticForce;
    static_assert(sizeof(float) == 4,
        "float has an invalid size on this platform and can not be used");
    data.data.primaryYMagneticForce = primaryYMagneticForce;
    static_assert(sizeof(float) == 4,
        "float has an invalid size on this platform and can not be used");
    data.data.primaryZMagneticForce = primaryZMagneticForce;
    static_assert(sizeof(float) == 4,
        "float has an invalid size on this platform and can not be used");
    data.data.secondaryXAcceleration = secondaryXAcceleration;
    static_assert(sizeof(float) == 4,
        "float has an invalid size on this platform and can not be used");
    data.data.secondaryYAcceleration = secondaryYAcceleration;
    static_assert(sizeof(float) == 4,
        "float has an invalid size on this platform and can not be used");
    data.data.secondaryZAcceleration = secondaryZAcceleration;
    static_assert(sizeof(float) == 4,
        "float has an invalid size on this platform and can not be used");
    data.data.secondaryXMagneticForce = secondaryXMagneticForce;
    static_assert(sizeof(float) == 4,
        "float has an invalid size on this platform and can not be used");
    data.data.secondaryYMagneticForce = secondaryYMagneticForce;
    static_assert(sizeof(float) == 4,
        "float has an invalid size on this platform and can not be used");
    data.data.secondaryZMagneticForce = secondaryZMagneticForce;
    static_assert(sizeof(float) == 4,
        "float has an invalid size on this platform and can not be used");
    data.data.pressure = pressure;
    static_assert(sizeof(float) == 4,
        "float has an invalid size on this platform and can not be used");
    data.data.state = (uint8_t) state;
    data.header.checksum = calculateChecksum(
        &((uint8_t*) &data.header.checksum)[sizeof(data.header.checksum)],
        messageSize - sizeof(data.header.syncByte1)
        - sizeof(data.header.syncByte2) - sizeof(data.header.checksum));
    return writeTelemetry(&data, messageSize);
}

bool sendTelemetryData3(ms_t time, const Quaternion* orientation, voltFloat_t batteryLevel) {
    size_t messageSize = sizeof(TelemetryData3Type);
    TelemetryData3Type data;
    data.header.syncByte1 = SYNC_BYTE_1;
    data.header.syncByte2 = SYNC_BYTE_2;
    data.header.type = (uint8_t) TELEMETRY_DATA3;
    data.data.time = time;
    memcpy(&data.data.orientation, orientation, sizeof(data.data.orientation));
    data.data.batteryLevel = batteryLevel;
    static_assert(sizeof(float) == 4,
        "float has an invalid size on this platform and can not be used");
    data.header.checksum = calculateChecksum(
        &((uint8_t*) &data.header.checksum)[sizeof(data.header.checksum)],
        messageSize - sizeof(data.header.syncByte1)
        - sizeof(data.header.syncByte2) - sizeof(data.header.checksum));
    return writeTelemetry(&data, messageSize);
}

bool sendTelemetryDataMotorSpeeds(uint8_t motorSpeedCount, const Vec3FWithTime* motorSpeeds) {
    size_t messageSize = sizeof(TelemetryDataMotorSpeedsType) + motorSpeedCount *
        sizeof(motorSpeeds[0]);
    uint8_t dataBuffer[messageSize];
    TelemetryDataMotorSpeedsType* data = (TelemetryDataMotorSpeedsType*) dataBuffer;
    data->header.syncByte1 = SYNC_BYTE_1;
    data->header.syncByte2 = SYNC_BYTE_2;
    data->header.type = (uint8_t) TELEMETRY_DATA_MOTOR_SPEEDS;
    data->data.motorSpeedCount = motorSpeedCount;
    memcpy(&data->data.motorSpeeds, motorSpeeds, motorSpeedCount * sizeof(motorSpeeds[0]));
    data->header.checksum = calculateChecksum(
        &((uint8_t*) &data->header.checksum)[sizeof(data->header.checksum)],
        messageSize - sizeof(data->header.syncByte1)
        - sizeof(data->header.syncByte2) - sizeof(data->header.checksum));
    return writeTelemetry(data, messageSize);
}

bool sendTelemetryDataRotationSpeeds(uint8_t rotationSpeedCount, const Vec3FWithTime* rotationSpeeds) {
    size_t messageSize = sizeof(TelemetryDataRotationSpeedsType) + rotationSpeedCount *
        sizeof(rotationSpeeds[0]);
    uint8_t dataBuffer[messageSize];
    TelemetryDataRotationSpeedsType* data = (TelemetryDataRotationSpeedsType*) dataBuffer;
    data->header.syncByte1 = SYNC_BYTE_1;
    data->header.syncByte2 = SYNC_BYTE_2;
    data->header.type = (uint8_t) TELEMETRY_DATA_ROTATION_SPEEDS;
    data->data.rotationSpeedCount = rotationSpeedCount;
    memcpy(&data->data.rotationSpeeds, rotationSpeeds, rotationSpeedCount * sizeof(rotationSpeeds[0]));
    data->header.checksum = calculateChecksum(
        &((uint8_t*) &data->header.checksum)[sizeof(data->header.checksum)],
        messageSize - sizeof(data->header.syncByte1)
        - sizeof(data->header.syncByte2) - sizeof(data->header.checksum));
    return writeTelemetry(data, messageSize);
}

bool sendTelemetryDataSetPoints(uint8_t setPointsCount, const Vec3Int32WithTime* setPoints) {
    size_t messageSize = sizeof(TelemetryDataSetPointsType) + setPointsCount * sizeof(setPoints[0]);
    uint8_t dataBuffer[messageSize];
    TelemetryDataSetPointsType* data = (TelemetryDataSetPointsType*) dataBuffer;
    data->header.syncByte1 = SYNC_BYTE_1;
    data->header.syncByte2 = SYNC_BYTE_2;
    data->header.type = (uint8_t) TELEMETRY_DATA_SET_POINTS;
    data->data.setPointsCount = setPointsCount;
    memcpy(&data->data.setPoints, setPoints, setPointsCount * sizeof(setPoints[0]));
    data->header.checksum = calculateChecksum(
        &((uint8_t*) &data->header.checksum)[sizeof(data->header.checksum)],
        messageSize - sizeof(data->header.syncByte1)
        - sizeof(data->header.syncByte2) - sizeof(data->header.checksum));
    return writeTelemetry(data, messageSize);
}

bool sendTelemetryDataRecovery(ms_t time, ms_t gpsTime, deg_t longitude, deg_t latitude,
    meter_t height, RecoveryState recoveryState) {
    size_t messageSize = sizeof(TelemetryDataRecoveryType);
    TelemetryDataRecoveryType data;
    data.header.syncByte1 = SYNC_BYTE_1;
    data.header.syncByte2 = SYNC_BYTE_2;
    data.header.type = (uint8_t) TELEMETRY_DATA_RECOVERY;
    data.data.time = time;
    data.data.gpsTime = gpsTime;
    data.data.longitude = longitude;
    static_assert(sizeof(double) == 8,
        "double has an invalid size on this platform and can not be used");
    data.data.latitude = latitude;
    static_assert(sizeof(double) == 8,
        "double has an invalid size on this platform and can not be used");
    data.data.height = height;
    static_assert(sizeof(double) == 8,
        "double has an invalid size on this platform and can not be used");
    data.data.recoveryState = (uint8_t) recoveryState;
    data.header.checksum = calculateChecksum(
        &((uint8_t*) &data.header.checksum)[sizeof(data.header.checksum)],
        messageSize - sizeof(data.header.syncByte1)
        - sizeof(data.header.syncByte2) - sizeof(data.header.checksum));
    return writeTelemetry(&data, messageSize);
}
